Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2038)
@@ -130,5 +130,5 @@
                DO ji = 1, jpi
                   zvol = cvol(ji,jj,jk)
-#  if defined key_off_degrad
+#  if defined key_degrad
                   zvol = zvol * facvol(ji,jj,jk)
 #  endif
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2038)
@@ -26,6 +26,6 @@
    USE p4zflx          ! 
 
-   USE trdmld_trc_oce
-   USE trdmld_trc
+   USE trdmod_oce
+   USE trdmod_trc
 
    USE sedmodel
@@ -94,5 +94,5 @@
           DO jn = jp_pcs0, jp_pcs1
             ztrpis(:,:,:) = tra(:,:,:,jn)
-            CALL trd_mod_trc( ztrpis, jn, jptrc_trd_sms, kt )   ! save trends
+            CALL trd_mod_trc( ztrpis, jn, jptra_trd_sms, kt )   ! save trends
           END DO
       END IF
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/oce_trc.F90	(revision 2038)
@@ -32,4 +32,6 @@
    USE par_oce , ONLY :   jpkdta   =>   jpkdta     !: number of levels            > or = jpk
    USE par_oce , ONLY :   lk_esopa =>   lk_esopa   !: flag to activate the all option
+   USE par_oce , ONLY :   jp_tem   =>   jp_tem     !: indice for temperature
+   USE par_oce , ONLY :   jp_sal   =>   jp_sal     !: indice for salinity
 
    !* IO manager *
@@ -112,13 +114,13 @@
    USE dom_oce , ONLY :   ln_zco     =>  ln_zco      !: z-coordinate flag
    USE dom_oce , ONLY :   lk_zco     =>  lk_zco      !: z-coordinate flag (1D or 3D arrays)
-   USE dom_oce , ONLY :   hbatt      =>   hbatt      !: ocean depth at the vertical of  t-point (m)
-   USE dom_oce , ONLY :   hbatu      =>   hbatu      !: ocean depth at the vertical of  u-point (m)
-   USE dom_oce , ONLY :   hbatv      =>   hbatv      !: ocean depth at the vertical of w-point (m)
-   USE dom_oce , ONLY :   gsigt      =>   gsigt      !: model level depth coefficient at T-levels
-   USE dom_oce , ONLY :   gsigw      =>   gsigw      !: model level depth coefficient at W-levels
-   USE dom_oce , ONLY :   gsi3w      =>   gsi3w      !: model level depth coef at w-levels (defined as the sum of e3w)
-   USE dom_oce , ONLY :   esigt      =>   esigt      !: vertical scale factor coef. at t-levels
-   USE dom_oce , ONLY :   esigw      =>   esigw      !: vertical scale factor coef. at w-levels
-   USE dom_oce , ONLY :   lk_vvl     => lk_vvl       !: variable grid flag
+   USE dom_oce , ONLY :   hbatt      =>  hbatt      !: ocean depth at the vertical of  t-point (m)
+   USE dom_oce , ONLY :   hbatu      =>  hbatu      !: ocean depth at the vertical of  u-point (m)
+   USE dom_oce , ONLY :   hbatv      =>  hbatv      !: ocean depth at the vertical of w-point (m)
+   USE dom_oce , ONLY :   gsigt      =>  gsigt      !: model level depth coefficient at T-levels
+   USE dom_oce , ONLY :   gsigw      =>  gsigw      !: model level depth coefficient at W-levels
+   USE dom_oce , ONLY :   gsi3w      =>  gsi3w      !: model level depth coef at w-levels (defined as the sum of e3w)
+   USE dom_oce , ONLY :   esigt      =>  esigt      !: vertical scale factor coef. at t-levels
+   USE dom_oce , ONLY :   esigw      =>  esigw      !: vertical scale factor coef. at w-levels
+   USE dom_oce , ONLY :   lk_vvl     =>  lk_vvl       !: variable grid flag
 
    !* masks, bathymetry *
@@ -129,5 +131,5 @@
    USE dom_oce , ONLY :   vmask      =>   vmask      !: land/ocean mask at v-points 
    USE dom_oce , ONLY :   fmask      =>   fmask      !: land/ocean mask at f-points 
-# if defined key_off_degrad
+# if defined key_degrad
    USE dom_oce , ONLY :   facvol     =>   facvol     !: volume factor for degradation
 # endif
@@ -166,8 +168,12 @@
    USE oce , ONLY :   tn      =>    tn      !: pot. temperature (celsius)
    USE oce , ONLY :   sn      =>    sn      !: salinity (psu)
+   USE oce , ONLY :   tsn     =>    tsn     !: 4D array contaning ( tn, sn )
+   USE oce , ONLY :   tsb     =>    tsb     !: 4D array contaning ( tb, sb )
+   USE oce , ONLY :   tsa     =>    tsa     !: 4D array contaning ( ta, sa )
    USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
    USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
    USE oce , ONLY :   hdivn   =>    hdivn   !: horizontal divergence (1/s)
-#if defined key_off_tra
+   USE oce , ONLY :   l_traldf_rot => l_traldf_rot  !: rotated laplacian operator for lateral diffusion
+#if defined key_offline
    USE oce , ONLY :   gtu     =>    gtu     !: t-, s- and rd horizontal gradient at u- and
    USE oce , ONLY :   gsu     =>    gsu     !: v-points at bottom ocean level
@@ -196,13 +202,5 @@
    USE sbcrnf  , ONLY :   rnfmsk_z   =>    rnfmsk_z   !: mixed adv scheme in runoffs vicinity (vert.)
 
-   !* bottom boundary layer *
-# if   defined key_trabbl_dif   ||   defined key_trabbl_adv
-# if ! defined key_off_tra 
-   USE trabbl , ONLY :   atrbbl   =>   rn_ahtbbl     !: lateral coeff. for bottom boundary layer scheme (m2/s)
-# else 
-   USE trabbl, ONLY :   bblx   => bblx         !: ???
-   USE trabbl, ONLY :   bbly   => bbly         !: ???
-#  endif
-# endif
+   USE trc_oce
 
    !* lateral diffusivity (tracers) *
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/par_trc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/par_trc.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/par_trc.F90	(revision 2038)
@@ -40,35 +40,4 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_trc_c1d   = .FALSE.  !: 1D pass. tracer configuration flag
 # endif
-   ! Passive tracers : size for TRP trends diagnotics (used if 'key_trc_diatrd' defined)
-# if defined key_trc_diatrd
-   ! Passive tracers : size for TRP trends diagnotics (used if 'key_trc_diatrd' defined)
-   INTEGER, PARAMETER ::   jptrc_xad     =  1   !: x- horizontal advection
-   INTEGER, PARAMETER ::   jptrc_yad     =  2   !: y- horizontal advection
-   INTEGER, PARAMETER ::   jptrc_zad     =  3   !: z- vertical   advection
-   INTEGER, PARAMETER ::   jptrc_xdf     =  4   !: lateral       diffusion
-   INTEGER, PARAMETER ::   jptrc_ydf     =  5   !: lateral       diffusion
-   INTEGER, PARAMETER ::   jptrc_zdf     =  6   !: vertical diffusion (Kz)
-   INTEGER, PARAMETER ::   jptrc_sbc     =  7   !: surface boundary condition
-#if ! defined key_trcldf_eiv && ! defined key_trcdmp
-   INTEGER, PARAMETER ::   jpdiatrc      =  7  !: trends: 3*(advection + diffusion       ) + sbc
-#endif
-#if defined key_trcldf_eiv && defined key_trcdmp
-   INTEGER, PARAMETER ::   jptrc_xei     =  8   !: x- horiz. EIV advection
-   INTEGER, PARAMETER ::   jptrc_yei     =  9   !: y- horiz. EIV advection
-   INTEGER, PARAMETER ::   jptrc_zei     = 10   !: z- vert.  EIV advection
-   INTEGER, PARAMETER ::   jptrc_dmp     = 11   !: damping
-   INTEGER, PARAMETER ::   jpdiatrc      = 11   !: trends: 3*(advection + diffusion + eiv ) + sbc + damping
-#endif
-#if defined key_trcldf_eiv && ! defined key_trcdmp
-   INTEGER, PARAMETER ::   jptrc_xei     =  8   !: x- horiz. EIV advection
-   INTEGER, PARAMETER ::   jptrc_yei     =  9   !: y- horiz. EIV advection
-   INTEGER, PARAMETER ::   jptrc_zei     = 10   !: z- vert.  EIV advection
-   INTEGER, PARAMETER ::   jpdiatrc      = 10   !: trends: 3*(advection + diffusion + eiv ) + sbc 
-#endif
-#if ! defined key_trcldf_eiv && defined key_trcdmp
-   INTEGER, PARAMETER ::   jptrc_dmp     =  8   !: damping
-   INTEGER, PARAMETER ::   jpdiatrc      =  8   !: trends: 3*(advection + diffusion       ) + sbc + damping
-#endif
-#endif
 
    REAL(wp), PUBLIC  :: rtrn  = 1.e-15      !: truncation value     
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trc.F90	(revision 2038)
@@ -34,6 +34,5 @@
    INTEGER, PUBLIC                   ::   numnat   !: the number of the passive tracer NAMELIST
    LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutini   !:  initialisation from FILE or not (NAMELIST)
-   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutsav   !:  logical for saving tracer or not
-   INTEGER, PUBLIC, DIMENSION(jptra) ::   nutini   !: FORTRAN LOGICAL UNIT for initialisation file
+   LOGICAL, PUBLIC, DIMENSION(jptra) ::   lutsav   !:  save the tracer or not
 
    !! passive tracers fields (before,now,after)
@@ -47,14 +46,24 @@
    REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jpk,jptra) ::   trb   !: traceur concentration for before time step
 
+   !! isopycnal scheme for passive tracers
+   !! ------------------------------------  
+   REAL(wp), PUBLIC ::   ahtrb0     !: background diffusivity coefficient for passive tracer (m2/s)
+
+#if ! defined key_zco
+   !! interpolated gradient
+   !!--------------------------------------------------  
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtru   !: horizontal gradient at u-points at bottom ocean level
+   REAL(wp), PUBLIC, DIMENSION (jpi,jpj,jptra) ::   gtrv   !: horizontal gradient at v-points at bottom ocean level
+#endif
    
    !! passive tracers restart (input and output)
    !! ------------------------------------------  
-   INTEGER , PUBLIC  ::  ndttrc     !: frequency of step on passive tracers
-   INTEGER , PUBLIC  ::  nittrc000  !: first time step of passive tracers model
-   LOGICAL , PUBLIC  ::  ln_rsttr     !: boolean term for restart i/o for passive tracers (namelist)
-   LOGICAL , PUBLIC  ::  lrst_trc   !: logical to control the trc restart write
-   INTEGER , PUBLIC  ::  nutwrs     !: output FILE for passive tracers restart
-   INTEGER , PUBLIC  ::  nutrst     !: logical unit for restart FILE for passive tracers
-   INTEGER , PUBLIC  ::  nrsttr     !: control of the time step ( 0 or 1 ) for pass. tr.
+   INTEGER , PUBLIC  ::  nn_dttrc      !: frequency of step on passive tracers
+   INTEGER , PUBLIC  ::  nittrc000     !: first time step of passive tracers model
+   LOGICAL , PUBLIC  ::  ln_rsttr      !: boolean term for restart i/o for passive tracers (namelist)
+   LOGICAL , PUBLIC  ::  lrst_trc      !: logical to control the trc restart write
+   INTEGER , PUBLIC  ::  nutwrs        !: output FILE for passive tracers restart
+   INTEGER , PUBLIC  ::  nutrst        !: logical unit for restart FILE for passive tracers
+   INTEGER , PUBLIC  ::  nn_rsttr      !: control of the time step ( 0 or 1 ) for pass. tr.
    CHARACTER(len=50) ::  cn_trcrst_in  !: suffix of pass. tracer restart name (input)
    CHARACTER(len=50) ::  cn_trcrst_out !: suffix of pass. tracer restart name (output)
@@ -62,7 +71,7 @@
    !! information for outputs
    !! --------------------------------------------------
-   INTEGER , PUBLIC ::   nwritetrc   !: time step frequency for concentration outputs (namelist)
+   INTEGER , PUBLIC ::   nn_writetrc   !: time step frequency for concentration outputs (namelist)
    
-# if defined key_trc_diaadd && ! defined key_iomput
+# if defined key_diatrc && ! defined key_iomput
    !! additional 2D/3D outputs namelist
    !! --------------------------------------------------
@@ -80,5 +89,5 @@
 # endif
 
-#if defined key_trc_diabio || defined key_trdmld_trc
+#if defined key_diabio || defined key_trdmld_trc
    CHARACTER(len=8),  DIMENSION(jpdiabio) ::   ctrbio   !: biological trends name      (NAMELIST)
    CHARACTER(len=20), DIMENSION(jpdiabio) ::   ctrbiu   !: biological trends unit      (NAMELIST)
@@ -86,5 +95,5 @@
    INTEGER ::   nwritebio   !: time step frequency for biological outputs (NAMELIST)
 #endif
-# if defined key_trc_diabio
+# if defined key_diabio
    !! Biological trends
    !! -----------------
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcdia.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcdia.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcdia.F90	(revision 2038)
@@ -17,5 +17,4 @@
    !! trc_dia     : main routine of output passive tracer
    !! trcdit_wr   : outputs of concentration fields
-   !! trcdid_wr   : outputs of dvection-diffusion trends
    !! trcdii_wr   : outputs of additional 2D/3D diagnostics
    !! trcdib_wr   : outputs of biological fields
@@ -24,7 +23,5 @@
    USE oce_trc
    USE trc
-   USE trp_trc
    USE par_trc
-   USE trdmld_trc_oce, ONLY : luttrd
    USE dianam    ! build name of file (routine)
    USE in_out_manager  ! I/O manager
@@ -45,15 +42,10 @@
    INTEGER , DIMENSION (jpij*jpk) ::   ndext50   !: integer arrays for ocean 3D index
    INTEGER , DIMENSION (jpij)     ::   ndext51   !: integer arrays for ocean surface index
-# if defined key_trc_diaadd
+# if defined key_diatrc
    INTEGER  ::   nitd      !: id for additional array output file
    INTEGER  ::   ndepitd   !: id for depth mesh
    INTEGER  ::   nhoritd   !: id for horizontal mesh
 # endif
-# if defined key_trc_diatrd
-   INTEGER , DIMENSION (jptra) ::   nit6      !: id for additional array output file
-   INTEGER , DIMENSION (jptra) ::   ndepit6   !: id for depth mesh
-   INTEGER , DIMENSION (jptra) ::   nhorit6   !: id for horizontal mesh
-# endif
-# if defined key_trc_diabio
+# if defined key_diabio
    INTEGER  ::   nitb        !:         id.         for additional array output file
    INTEGER  ::   ndepitb   !:  id for depth mesh
@@ -82,5 +74,4 @@
       
       CALL trcdit_wr( kt, kindic )      ! outputs for tracer concentration
-      CALL trcdid_wr( kt, kindic )      ! outputs for dynamical trends
       CALL trcdii_wr( kt, kindic )      ! outputs for additional arrays
       CALL trcdib_wr( kt, kindic )      ! outputs for biological trends
@@ -111,5 +102,5 @@
       LOGICAL ::   ll_print = .FALSE.
       CHARACTER (len=40) :: clhstnam, clop
-#if defined key_off_tra
+#if defined key_offline
       INTEGER ::   inum = 11             ! temporary logical unit
 #endif
@@ -133,5 +124,5 @@
       ENDIF
 # if defined key_diainstant
-      zsto = nwritetrc * rdt
+      zsto = nn_writetrc * rdt
       clop = "inst("//TRIM(clop)//")"
 # else
@@ -139,5 +130,5 @@
       clop = "ave("//TRIM(clop)//")"
 # endif
-      zout = nwritetrc * zdt
+      zout = nn_writetrc * zdt
 
       ! Define indices of the horizontal output zoom and vertical limit storage
@@ -168,8 +159,8 @@
             &                    ' limit storage in depth = ', ipk
 
-#if defined key_off_tra
+#if defined key_offline
         ! WRITE root name in date.file for use by postpro
          IF(lwp) THEN
-            CALL dia_nam( clhstnam, nwritetrc,' ' )
+            CALL dia_nam( clhstnam, nn_writetrc,' ' )
             CALL ctlopn( inum, 'date.file', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', 1, numout, lwp, narea )
             WRITE(inum,*) clhstnam
@@ -179,5 +170,5 @@
 
          ! Define the NETCDF files for passive tracer concentration
-         CALL dia_nam( clhstnam, nwritetrc, 'ptrc_T' )
+         CALL dia_nam( clhstnam, nn_writetrc, 'ptrc_T' )
          IF(lwp)WRITE(numout,*)" Name of NETCDF file ", clhstnam
 
@@ -216,5 +207,5 @@
       ! ---------------------------------------
 
-      IF( lwp .AND. MOD( itmod, nwritetrc ) == 0 ) THEN
+      IF( lwp .AND. MOD( itmod, nn_writetrc ) == 0 ) THEN
          WRITE(numout,*) 'trcdit_wr : write NetCDF passive tracer concentrations at ', kt, 'time-step'
          WRITE(numout,*) '~~~~~~~~~ '
@@ -233,235 +224,5 @@
    END SUBROUTINE trcdit_wr
 
-# if defined key_trc_diatrd
-
-   SUBROUTINE trcdid_wr( kt, kindic )
-      !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trcdid_wr  ***
-      !!
-      !! ** Purpose :   output of passive tracer : advection-diffusion trends
-      !!
-      !! ** Method  :   At the beginning of the first time step (nit000), define all
-      !!             the NETCDF files and fields for concentration of passive tracer
-      !!
-      !!        At each time step call histdef to compute the mean if necessary
-      !!        Each nwritetrd time step, output the instantaneous or mean fields
-      !!
-      !!        IF kindic <0, output of fields before the model interruption.
-      !!        IF kindic =0, time step loop
-      !!        IF kindic >0, output of fields before the time step loop
-      !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step
-      INTEGER, INTENT( in ) ::   kindic      ! indicator of abnormal termination
-      !!
-      LOGICAL ::   ll_print = .FALSE.
-      CHARACTER (len=40) ::   clhstnam, clop
-      CHARACTER (len=20) ::   cltra, cltrau
-      CHARACTER (len=80) ::   cltral
-      CHARACTER (len=10) ::   csuff
-      INTEGER  ::   jn, jl, ikn
-      INTEGER  ::   iimi, iima, ijmi, ijma, ipk, it, itmod
-      REAL(wp) ::   zsto, zout, zdt
-      !!----------------------------------------------------------------------
-
-      ! 0. Initialisation
-      ! -----------------
-      
-
-      ! local variable for debugging
-      ll_print = .FALSE.
-      ll_print = ll_print .AND. lwp
-      !
-      ! Define frequency of output and means
-      zdt = rdt
-      IF( ln_mskland )   THEN   ;   clop = "only(x)"   ! put 1.e+20 on land (very expensive!!)
-      ELSE                      ;   clop = "x"         ! no use of the mask value (require less cpu time)
-      ENDIF
-#  if defined key_diainstant
-      zsto = nwritetrd * rdt
-      clop = "inst("//TRIM(clop)//")"
-#  else
-      zsto = zdt
-      clop = "ave("//TRIM(clop)//")"
-#  endif
-      zout = nwritetrd * zdt
-
-      ! Define indices of the horizontal output zoom and vertical limit storage
-      iimi = 1      ;      iima = jpi
-      ijmi = 1      ;      ijma = jpj
-      ipk = jpk
-
-      ! define time axis
-      itmod = kt - nittrc000 + 1
-      it    = kt
-
-      ! Define the NETCDF files (one per tracer)
-      IF( ll_print ) WRITE(numout,*) 'trcdid kt=', kt, ' kindic ', kindic
-      
-      
-      IF( kt == nittrc000 ) THEN
-
-         DO jn = 1, jptra
-            !
-            IF( luttrd(jn) ) THEN      ! Define the file for dynamical trends - one per each tracer IF required
-
-               IF(lwp)WRITE(numout,*) ' indexes of zoom = ', iimi, iima, ijmi, ijma,  &
-                   &                   ' limit storage in depth = ', ipk
-               csuff='DY_'//ctrcnm(jn)
-               CALL dia_nam( clhstnam, nwritetrd, csuff )
-               IF(lwp)WRITE(numout,*)   " Name of NETCDF file for dynamical trends",   &
-                  &                     " of tracer number : ",clhstnam
-
-               CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,       &
-                  &          iimi, iima-iimi+1, ijmi, ijma-ijmi+1,   &
-                  &          nittrc000-ndttrc, zjulian, zdt, nhorit6(jn),  &
-                  &          nit6(jn) , domain_id=nidom )
-
-               ! Vertical grid for tracer trend - one per each tracer IF needed
-               CALL histvert( nit6(jn), 'deptht', 'Vertical T levels', 'm', ipk, gdept_0, ndepit6(jn) ) 
-             END IF
-          END DO
-
-          ! Declare all the output fields as NETCDF variables
-          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
-                DO jl = 1, jpdiatrc
-                  IF( jl == jptrc_xad ) THEN
-                      ! short and long title for x advection for tracer
-                      WRITE (cltra,'("XAD_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("X advective trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-                  IF( jl == jptrc_yad ) THEN
-                      ! short and long title for y advection for tracer
-                      WRITE (cltra,'("YAD_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Y advective trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-                  IF( jl == jptrc_zad ) THEN
-                      ! short and long title for Z advection for tracer
-                      WRITE (cltra,'("ZAD_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Z advective trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-                  IF( jl == jptrc_xdf ) THEN
-                      ! short and long title for X diffusion for tracer
-                      WRITE (cltra,'("XDF_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("X diffusion trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-                  IF( jl == jptrc_ydf ) THEN
-                      ! short and long title for Y diffusion for tracer
-                      WRITE (cltra,'("YDF_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Y diffusion trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-                  IF( jl == jptrc_zdf ) THEN
-                      ! short and long title for Z diffusion for tracer
-                      WRITE (cltra,'("ZDF_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Z diffusion trend for ",58a)') ctrcnl(jn)(1:58)
-                  END IF
-# if defined key_trcldf_eiv
-                  IF( jl == jptrc_xei ) THEN
-                      ! short and long title for x gent velocity for tracer
-                      WRITE (cltra,'("XGV_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("X gent velocity trend for ",53a)') ctrcnl(jn)(1:53)
-                  END IF
-                  IF( jl == jptrc_yei ) THEN
-                      ! short and long title for y gent velocity for tracer
-                      WRITE (cltra,'("YGV_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Y gent velocity trend for ",53a)') ctrcnl(jn)(1:53)
-                  END IF
-                  IF( jl == jptrc_zei ) THEN
-                      ! short and long title for Z gent velocity for tracer
-                      WRITE (cltra,'("ZGV_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Z gent velocity trend for ",53a)') ctrcnl(jn)(1:53)
-                  END IF
-# endif
-# if defined key_trcdmp
-                  IF( jl == jptrc_dmp ) THEN
-                      ! last trends for tracer damping : short and long title
-                      WRITE (cltra,'("TDM_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Tracer damping trend for ",55a)') ctrcnl(jn)(1:55)
-                  END IF
-# endif
-                  IF( jl == jptrc_sbc ) THEN
-                      ! last trends for tracer damping : short and long title
-                      WRITE (cltra,'("SBC_",16a)') ctrcnm(jn)
-                      WRITE (cltral,'("Surface boundary flux ",58a)') ctrcnl(jn)(1:55)
-                  END IF
-                      WRITE (cltral,'("Surface boundary flux ",58a)') ctrcnl(jn)(1:55)
-                  END IF
-                  CALL FLUSH( numout )
-                  cltrau = ctrcun(jn)      ! UNIT for tracer /trends
-                  CALL histdef( nit6(jn), cltra, cltral, cltrau, jpi,jpj,  &
-                     &          nhorit6(jn), ipk, 1, ipk,  ndepit6(jn), 32, clop ,  &
-                     &          zsto,zout )
-               END DO
-            END IF
-         END DO
-         ! CLOSE netcdf Files
-          DO jn = 1, jptra
-             IF( luttrd(jn) )   CALL histend( nit6(jn) )
-          END DO
-
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'End of NetCDF Initialization in trcdid'
-         IF(ll_print) CALL FLUSH(numout )
-         !
-      ENDIF
-
-      ! SOME diagnostics to DO first time
-
-      ! Start writing data
-      ! ---------------------
-
-      ! trends for tracer concentrations
-
-      IF( lwp .AND. MOD( itmod, nwritetrd ) == 0 ) THEN
-         WRITE(numout,*) 'trcdid_wr : write NetCDF dynamical trends at ', kt, 'time-step'
-         WRITE(numout,*) '~~~~~~ '
-      ENDIF
-
-      DO jn = 1, jptra
-         IF( luttrd(jn) ) THEN
-            ikn = ikeep(jn) 
-            DO jl = 1, jpdiatrc
-               ! short titles
-               IF( jl == jptrc_xad)   WRITE (cltra,'("XAD_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_yad)   WRITE (cltra,'("YAD_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_zad)   WRITE (cltra,'("ZAD_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_xdf)   WRITE (cltra,'("XDF_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_ydf)   WRITE (cltra,'("YDF_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_zdf)   WRITE (cltra,'("ZDF_",16a)') ctrcnm(jn)
-# if defined key_trcldf_eiv
-               IF( jl == jptrc_xei)   WRITE (cltra,'("XGV_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_yei)   WRITE (cltra,'("YGV_",16a)') ctrcnm(jn)
-               IF( jl == jptrc_zei)   WRITE (cltra,'("ZGV_",16a)') ctrcnm(jn)
-# endif
-# if defined key_trcdmp
-               IF( jl == jptrc_dmp )  WRITE (cltra,'("TDM_",16a)') ctrcnm(jn)
-# endif
-               IF( jl == jptrc_sbc )  WRITE (cltra,'("SBC_",16a)') ctrcnm(jn)
-               !
-               CALL histwrite(nit6(jn), cltra, it, trtrd(:,:,:,ikn,jl),ndimt50, ndext50)
-            END DO
-         END IF
-      END DO
-
-      ! Closing all files
-      ! -----------------
-      IF( kt == nitend .OR. kindic < 0 ) THEN
-         DO jn = 1, jptra
-            IF( luttrd(jn) )   CALL histclo( nit6(jn) )
-         END DO
-      ENDIF
-      !
-
-   END SUBROUTINE trcdid_wr
-
-# else
-
-   SUBROUTINE trcdid_wr( kt, kindic )                      ! Dummy routine
-      INTEGER, INTENT ( in ) ::   kt, kindic
-   END SUBROUTINE trcdid_wr
-
-# endif
-
-#if defined key_trc_diaadd
+#if defined key_diatrc
 
    SUBROUTINE trcdii_wr( kt, kindic )
@@ -506,5 +267,5 @@
       ENDIF
 #  if defined key_diainstant
-      zsto = nwritedia * zdt
+      zsto = nn_writedia * zdt
       clop = "inst("//TRIM(clop)//")"
 #  else
@@ -512,5 +273,5 @@
       clop = "ave("//TRIM(clop)//")"
 #  endif
-      zout = nwritedia * zdt
+      zout = nn_writedia * zdt
 
       ! Define indices of the horizontal output zoom and vertical limit storage
@@ -534,5 +295,5 @@
          ! Define the T grid file for tracer auxiliary files
 
-         CALL dia_nam( clhstnam, nwritedia, 'diad_T' )
+         CALL dia_nam( clhstnam, nn_writedia, 'diad_T' )
          IF(lwp) WRITE(numout,*) " Name of NETCDF file ", clhstnam
 
@@ -581,5 +342,5 @@
       ! ---------------------
 
-      IF( lwp .AND. MOD( itmod, nwritedia ) == 0 ) THEN
+      IF( lwp .AND. MOD( itmod, nn_writedia ) == 0 ) THEN
          WRITE(numout,*) 'trcdii_wr : write NetCDF additional arrays at ', kt, 'time-step'
          WRITE(numout,*) '~~~~~~ '
@@ -613,5 +374,5 @@
 # endif
 
-# if defined key_trc_diabio
+# if defined key_diabio
 
    SUBROUTINE trcdib_wr( kt, kindic )
@@ -658,5 +419,5 @@
       ENDIF
 #        if defined key_diainstant
-      zsto = nwritebio * zdt
+      zsto = nn_writebio * zdt
       clop = "inst("//TRIM(clop)//")"
 #        else
@@ -664,5 +425,5 @@
       clop = "ave("//TRIM(clop)//")"
 #        endif
-      zout = nwritebio * zdt
+      zout = nn_writebio * zdt
 
       ! Define indices of the horizontal output zoom and vertical limit storage
@@ -684,5 +445,5 @@
          ! Define the NETCDF files for biological trends
 
-         CALL dia_nam(clhstnam,nwritebio,'biolog')
+         CALL dia_nam(clhstnam,nn_writebio,'biolog')
          IF(lwp)WRITE(numout,*) " Name of NETCDF file for biological trends ", clhstnam
          ! Horizontal grid : glamt and gphit
@@ -716,5 +477,5 @@
 
       ! biological trends
-      IF( lwp .AND. MOD( itmod, nwritebio ) == 0 ) THEN
+      IF( lwp .AND. MOD( itmod, nn_writebio ) == 0 ) THEN
          WRITE(numout,*) 'trcdit_wr : write NetCDF biological trends at ', kt, 'time-step'
          WRITE(numout,*) '~~~~~~ '
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90	(revision 2037)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/TOP_SRC/trcini.F90	(revision 2038)
@@ -18,8 +18,6 @@
    USE oce_trc
    USE trc
-   USE trp_trc
    USE trcrst
-   USE trcctl
-   USE trclec
+   USE trcnam          ! Namelist read
    USE trcini_cfc      ! CFC      initialisation
    USE trcini_lobster  ! LOBSTER  initialisation
@@ -28,8 +26,8 @@
    USE trcini_my_trc   ! MY_TRC   initialisation
    USE trcdta   
-#if defined key_off_tra 
+#if defined key_offline
    USE daymod
 #endif
-   USE zpshde_trc      ! partial step: hor. derivative 
+   USE zpshde          ! partial step: hor. derivative   (zps_hde_trc routine)
    USE in_out_manager  ! I/O manager
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
@@ -78,14 +76,24 @@
 
       ! total volume of the ocean
-#if ! defined key_off_degrad
+#if ! defined key_degrad
       areatot = SUM( cvol(:,:,:) )
 #else
-      areatot = SUM( cvol(:,:,:) * facvol(:,:,:) ) ! degrad option: reduction by facvol
+      areatot = SUM( cvol(:,:,:) * facvol(:,:,:) )  ! degrad option: reduction by facvol
 #endif
-      IF( lk_mpp )   CALL mpp_sum( areatot )     ! sum over the global domain  
+      IF( lk_mpp )   CALL mpp_sum( areatot )        ! sum over the global domain  
 
-                                  CALL trc_lec      ! READ passive tracers namelists
+                                  CALL trc_nam      ! read passive tracers namelists
 
-                                  CALL trc_ctl      ! control consistency between parameters, cpp key
+      ! restart for passive tracer (input)
+      IF( ln_rsttr ) THEN
+         IF(lwp) WRITE(numout,*) '       read a restart file for passive tracer : ', cn_trcrst_in
+         IF(lwp) WRITE(numout,*) ' '
+      ELSE
+         IF(lwp) WRITE(numout,*)
+         DO jn = 1, jptra
+            IF( lwp .AND. lutini(jn) )  &                  ! open input FILE only IF lutini(jn) is true
+            &  WRITE(numout,*) '        read an initial file  for passive tracer number :', jn, ' traceur : ', ctrcnm(jn) 
+         END DO
+      ENDIF
 
       IF( lk_lobster ) THEN   ;   CALL trc_ini_lobster      ! LOBSTER bio-model
@@ -110,5 +118,5 @@
 
       IF( .NOT. ln_rsttr ) THEN 
-#if defined key_off_tra
+#if defined key_offline
          CALL day_init      ! calendar
 #endif
@@ -130,5 +138,5 @@
       
       IF( ln_zps .AND. .NOT. lk_trc_c1d )   &              ! Partial steps: before horizontal gradient of passive
-      &                     CALL zps_hde_trc( nittrc000, trb, gtru, gtrv )       ! tracers at the bottom ocean level
+      &                     CALL zps_hde_trc( nittrc000, jptra, trb, gtru, gtrv )       ! tracers at the bottom ocean level
 
 
@@ -136,5 +144,5 @@
       trai = 0.e0
       DO jn = 1, jptra
-#if ! defined key_off_degrad
+#if ! defined key_degrad
          trai = trai + SUM( trn(:,:,:,jn) * cvol(:,:,:) )
 #else
